% Batch run ssf
% set up scale-space siftflow
ssfConf = ssf_conf1();

parfor i = 1:length(ids)
	id=ids{i};

	srcFilename=[imageDir srcIds{i}];
	tgtFilename=[imageDir tgtIds{i}];

    im1 = imread(srcFilename);
    im2 = imread(tgtFilename);
   
   % reduce width to 500, reduce computation burden
   w = 500;
   if size(im1, 2) > w, im1 = imresize(im1, [NaN w]); end
   if size(im2, 2) > w, im2 = imresize(im2, [NaN w]); end
   
   fname = fullfile(flowDir, sprintf('%s.ssf.forward.mat', id));
   if ~exist(fname, 'file')
       [flow, label, ~, iter] = ssf(im1, im2, ssfConf);
       save_caller(fname, 'iter', iter);
   end
   
   fname = fullfile(flowDir, sprintf('%s.ssf.backward.mat', id));
   if ~exist(fname, 'file')
       [flow, label, ~, iter] = ssf(im2, im1, ssfConf);
       save_caller(fname, 'iter', iter);
   end
end
