function [scaleLabel, match] = ssf_init(p1, p2, initParams, scaleParams) 
    % SSF_INIT Multi-scale flow match, for initialization
    % label:    scale label
    % match:    flow for each scale
    % final output is u,v and scale label for each pixel
    
    % set paramater for this function
    match = struct('vx', [], 'vy', []);
    
    % Compute dense matching for each scale
    
    n1 = length(p1); n2 = length(p2);
    j = 1;
    for i = 1:n1
        sift1 = p1(i).sift;
        sift2 = p2(j).sift;
        % compute dense matching for single scale.
        [vx, vy] = ssf_SIFTflowc2f(sift1, sift2, initParams, false);
        warpSift2 = ssf_warp(sift2, vx, vy);
        siftDataTerm = sum(abs(double(warpSift2) - double(sift1)), 3);
        dataterm(:,:,i) = siftDataTerm;
        match(i).vx = vx; match(i).vy = vy;
    end

%     i = 1;
%     for j = 1:n2
%         sift1 = p1(i).sift;
%         sift2 = p2(j).sift;
%         % compute dense matching for single scale.
%         [vx, vy] = ssf_SIFTflowc2f(sift1, sift2, flow_p, false);
%         warpSift2 = warpImage(sift2, vx, vy);
%         siftDataTerm = sum(abs(double(warpSift2) - double(sift1)), 3);
%         dataterm(:,:,j+n1) = siftDataTerm;
%         match(j+n1).vx = vx; match(j+n1).vy = vy;
%     end
    scaleLabel = ssf_MRF_scale(dataterm, scaleParams.beta, scaleParams.tau);
end

