function [warpSrc, warpTgt, flowImg] = warp(srcIm, tgtIm, cFlow)
    dIm1 = im2double(srcIm); d_im2 = im2double(tgtIm);
    
    warpTgt = ssf_warp(d_im2,cFlow(:,:,1), cFlow(:,:,2));
    assert(isequal(size(warpTgt), size(srcIm)));
    warpI1_ = warpInverse(dIm1, cFlow(:,:,1), cFlow(:,:,2));
    % make warpI1_ same size as im2
    h = min(size(warpI1_, 1), size(tgtIm, 1)); 
    w = min(size(warpI1_,2), size(tgtIm,2));
    
    warpSrc = d_im2 .* 0;
    warpSrc(1:h, 1:w, :) = warpI1_(1:h, 1:w, :);
    assert(isequal(size(warpSrc), size(tgtIm)));
    flowImg = flowToColor(cFlow);
end

function [warpI1] = warpInverse(dim1, vx, vy)
% dim2 = im2double(im2);
    [h, w, c] = size(dim1);
    [XX, YY] = meshgrid(1:w, 1:h);

    XX1 = XX - vx; % index of left image
    YY1 = YY - vy;
    mask = (XX1 < 1) | (XX1 > w) | (YY1 < 1) | (YY1 > h);
    for i =1:3
        tmp = interp2(XX, YY, dim1(:,:,i), XX1, YY1);
        tmp(mask) = 120./255;
        warpI1(:,:,i) = tmp;
    end
end

